%global momorel 5

%global winedir	/var/lib/wine
%global _includedir /usr/include/wine

Summary: WINE Is Not an Emulators - runs MS Windows programs
Name: wine
Version: 20040505
Release: %{momorel}m
License: LGPL
Group: Applications/Emulators
%NoSource 0 ftp://ftp.ibiblio.org/pub/Linux/ALPHA/wine/development/Wine-%{version}.tar.gz 80db8c5c0ca2e0733bf232017a558757
Source1: wine.conf
Source2: wine.sh
Source3: wine.init
Source4: wine-20030115-regdefaults.tar.bz2
Source5: wine-setup.sh
## Patch2 is for systems jack sound server installed 
Patch2: wine-20030508-winejack.patch
Patch4: wine-20030709-ldconfig.patch
URL: http://www.winehq.com/
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: XFree86-devel bison flex >= 2.5 freetype2-devel
BuildRequires: perl ncurses-devel sgml-tools docbook-dtds cups-devel openjade
Requires: freetype2
ExclusiveArch: %{ix86}

%description
Wine is a program that allows running MS-Windows programs under X11.
It consists of a program loader, that loads and executes an
MS-Windows binary, and of an emulation library that translates Windows
API calls to their Unix/X11 equivalent.

%package devel
Summary: Development portion of Wine
Group: Development/Libraries
Requires: %{name} = %{version}

%description devel
Includes and headers to develop applications with the WINE libraries.

%package utils
Summary: Utilities of Wine
Group: Applications/Emulators
Requires: %{name} = %{version}

%description utils

Wine is a program which allows running Microsoft Windows programs
(including DOS, Windows 3.x and Win32 executables) on Unix.

This package consists many of the utilities provided by wine, both 
for compiling source using winelib and for running wine.  This
package is not strictly necessary.

%prep
%setup -q -a 4
%patch2 -p1 -b .winejack
%patch4 -p1 -b .ldconfig

%build
%configure --disable-debug --disable-trace --sysconfdir=%{_sysconfdir}/wine --with-x --enable-opengl
# dasa
perl -p -i -e 's/ -pthread//' dlls/winmm/winearts/Makefile
%make depend
%make
make -C documentation html

%install
rm -rf %{buildroot}
%makeinstall dlldir=%{buildroot}%{_libdir}/wine
mkdir -p %{buildroot}%{_sysconfdir}/wine
install -c tools/fnt2bdf %{buildroot}%{_bindir}/fnt2bdf

## install systemwide registry
install -c -m 0644 regdefaults/wine.*reg $RPM_BUILD_ROOT/etc/wine/
cp regdefaults/wine.*reg documentation/samples/
## install systemwide config file
sed -e "s|\"Path\" = \"\${HOME}/wine\"|;\"Path\" = \"\${HOME}/wine\"|" \
    %{SOURCE1} \
    | sed -e "s|;\"Path\" = \"/var/lib/wine\"|\"Path\" = \"/var/lib/wine\"|" \
    > $RPM_BUILD_ROOT/etc/wine/wine.conf
mv documentation/samples/config documentation/samples/config.orig
cp %{SOURCE1} documentation/samples/config

## install startup script
mv %{buildroot}%{_bindir}/wine %{buildroot}/%{_bindir}/wine.bin
install -m755 %{SOURCE2} %{buildroot}/%{_bindir}/wine

##install simple setup script
install  -m 755 %{SOURCE5} $RPM_BUILD_ROOT%{_bindir}/wine-setup

## make fake windows system directory
## this part refers to make_a_windows_system.sh in wine-20030408-3mdk.src.rpm of Mandrake Linux
mkdir -p $RPM_BUILD_ROOT%{winedir}
for i in system Desktop Favorites Fonts NetHood "Start Menu/Programs/Startup" \
         Recent SendTo ShellNew system32 Profiles/Administrator; do
	mkdir -p "$RPM_BUILD_ROOT%{winedir}/windows/$i"
done
mkdir -p "$RPM_BUILD_ROOT%{winedir}/Program Files/Common Files"
mkdir -p "$RPM_BUILD_ROOT%{winedir}/My Documents"
for i in shell.dll shell32.dll winsock.dll wnsock32.dll; do
	touch $RPM_BUILD_ROOT%{winedir}/windows/system/$i
done
touch $RPM_BUILD_ROOT%{winedir}/autoexec.bat
touch $RPM_BUILD_ROOT%{winedir}/config.sys
#install -c documentation/samples/system.ini $RPM_BUILD_ROOT/%{winedir}/windows/system.ini


## config-sample for users
mkdir -p $RPM_BUILD_ROOT%{_datadir}/config-sample/wine
install -c -m 0644 regdefaults/wine.*reg $RPM_BUILD_ROOT%{_datadir}/config-sample/wine
install -c -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/config-sample/wine
#install -c documentation/samples/system.ini $RPM_BUILD_ROOT/%{_datadir}/config-sample/wine

## Allow users to launch Windows programs by just clicking on the .exe file...
#mkdir -p $RPM_BUILD_ROOT%{_initrddir}
#install -m755 %{SOURCE3} $RPM_BUILD_ROOT%{_initrddir}/%{name}

#(from mandrake) make symlinks to utils in fake windows to dir
perl -e 'for $f (<%{buildroot}%{_libdir}/wine/*exe*>) { chomp($t = `basename $f`); $t =~ s/\.so$//; print "ln -s $f %{buildroot}%{winedir}/windows/$t\n"; }'| perl -pi -e "s#%{buildroot}%{_libdir}#%{_libdir}#g" | sh

#(from mandrake) winevdm.exe.so should go into wine package and not wine, and in stead of listing all files in %%files, just
# make a filelist without it
find $RPM_BUILD_ROOT{%{_libdir}/%{name},%{winedir}/windows}/*.exe*|grep -v winevdm.exe|sed "s|$RPM_BUILD_ROOT||g" > wine-utils-exe-files

# make symbolic link
ln -s %{_bindir}/wine-kthread %{buildroot}%{_bindir}/wine.bin-kthread
ln -s %{_bindir}/wine-pthread %{buildroot}%{_bindir}/wine.bin-pthread

%pre
# Add the "wine" group 
/usr/sbin/groupadd -g 66 -r wine &>/dev/null || :

%post
## Register the wine service
#/sbin/chkconfig --add wine

# Register a library path
grep -q "^/usr/lib/wine$" /etc/ld.so.conf || echo "/usr/lib/wine" >> /etc/ld.so.conf
/sbin/ldconfig

%preun
#/sbin/service wine stop > /dev/null 2>&1
#/sbin/chkconfig --del wine

%postun
if [ "$1" = "0" ]; then
    rm -f /etc/ld.so.conf.new
    grep -v -e "/usr/X11R6/lib/wine" -e "/usr/lib/wine" /etc/ld.so.conf > /etc/ld.so.conf.new
    mv -f /etc/ld.so.conf.new /etc/ld.so.conf
fi
/sbin/ldconfig

%clean
rm -rf %{buildroot}

%files
%defattr (-, root, root)
%doc README ANNOUNCE AUTHORS BUGS ChangeLog LICENSE DEVELOPERS-HINTS COPYING.LIB
%doc documentation/samples 
%doc documentation/wine-faq.html
%doc documentation/wine-user.html
%config(noreplace) %{_sysconfdir}/wine/*
#%config %{_initrddir}/wine
%{_bindir}/wine
%{_bindir}/wine-setup
%{_bindir}/wine.bin
%{_bindir}/wineconsole*
%{_bindir}/wineserver
%{_bindir}/wineboot
%{_bindir}/function_grep.pl
%{_bindir}/wineclipsrv
%{_bindir}/wineshelllink
%{_bindir}/wine-kthread
%{_bindir}/wine-pthread
%{_bindir}/wine.bin-kthread
%{_bindir}/wine.bin-pthread
%{_bindir}/wineprefixcreate
%{_bindir}/winebrowser
%{_libdir}/libwine*.so.*
%{_libdir}/%{name}/*.*.so
%{_mandir}/man1/wine.1*
%{_mandir}/man5/wine.conf.5*
%{_datadir}/config-sample/wine
%{_datadir}/wine/generic.ppd
%{_datadir}/wine/wine.inf
%attr(0775, root, wine) /var/lib/wine

%files devel
%defattr (-, root, root)
%doc DEVELOPERS-HINTS 
%doc documentation/wine-devel.html
%doc documentation/winelib-user.html
%{_libdir}/wine/*.a
%{_libdir}/libwine*.so
%{_libdir}/%{name}/*.def
%{_includedir}/*
%{_datadir}/aclocal/*
%{_bindir}/wmc
%{_mandir}/man1/wmc.1*
%{_bindir}/wrc
%{_mandir}/man1/wrc.1*
%{_bindir}/winebuild
%{_mandir}/man1/winebuild.1*
%{_mandir}/man1/widl.1*
%{_mandir}/man1/winedump.1*

%files utils -f wine-utils-exe-files
%defattr(-,root,root)
%doc LICENSE
%{_bindir}/fnt2bdf
%{_bindir}/notepad
%{_bindir}/progman
%{_bindir}/regedit
%{_bindir}/uninstaller
%{_bindir}/wcmd
%{_bindir}/winedbg
%{_bindir}/winedump
%{_bindir}/winemaker
%{_bindir}/winemine
%{_bindir}/winepath
%{_bindir}/winhelp
%{_bindir}/regsvr32
%{_bindir}/widl
%{_bindir}/winefile
%{_bindir}/winegcc
%{_bindir}/winecpp
%{_bindir}/wineg++
%{_bindir}/wineserver
%{_bindir}/winelauncher
#%{_bindir}/winewrap
%{_bindir}/winecfg
%{_mandir}/man1/winemaker.1*

%ChangeLog
* Thu Jul  1 2004 Kazuhiko <kazuhiko@fdiary.net>
- (20040505-5m)
- use sazanami instead of kochi

* Thu Jul 01 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (20040505-4m)
- rewind (20040615 causes some annoying errors in running windows binaries)

* Sun Jun 20 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (20040615-1m)
- update to release 20040615

* Wed Jun 09 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (20040505-3m)
- revise wine-setup.sh and wine.conf

* Tue May 25 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (20040505-2m)
- update to release 20040505

* Sat May 22 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (20040505-1m)
- update to release 20040505

* Wed May  5 2004 Toru Hoshina <t@momonga-linux.org>
- (20040121-2m)
- revise spec.

* Wed Jan 28 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (20040121-1m)
- update to release 20040121
- Full IME support for Asian locales seems to bigin, 
  but we still use XIM patch at http://sidenet.ddo.jp/winetips/ because 
  original IME support doesn't work well.
- [Input Method] section in ~/.wine/config has been obsoleted.

* Wed Dec 10 2003 Masayuki SANO <sano@acs.i.kyoto-u.ac.jp>
- (20031118-1m)
- update to release 20031118

* Mon Oct 20 2003 Masayuki SANO <sano@acs.i.kyoto-u.ac.jp>
- (20031016-1m)
- update to release 20031016
- use http://sidenet.ddo.jp/winetips/files/wine-20031016-xim-jp106.diff.zip (Source6) as a xim patch
- make html docs locally
- revise wine-setup.sh (no win.ini file now)

* Thu Aug 21 2003 Masayuki SANO <sano@acs.i.kyoto-u.ac.jp>
- (20030813-1m)
- revise a spec file ([Momonga-devel.ja:02026])
- update to release 20030813
- according to project homepage, what's new are
- - Partial implementation of the Microsoft Installer (msi.dll).
- - GUI for regedit (from ReactOS).
- - DirectMusic dlls reorganization.
- - Many Wininet improvements.
- - Lots of bug fixes.

* Sat Aug  9 2003 Masayuki SANO <sano@acs.i.kyoto-u.ac.jp>
- (20030709-1m)
- version 20030709
- The license has become LGPL
- import XIM patch (http://www.2chlinux.org/)
- make wine-utils subpackage and revise %%files (as Mandrake Cooker 20030709-2mdk)
- add simple setup script (wine-setup) to create config files and fake windows system directory
- revised and customized wine.conf in a new format
   (The location of "fake windows system" can be changed by modifying [Drive C] section in ~/.wine/config)
- install default registry files (from RedHat8 20020605-2)
- make systemwide fake windows system directory as /var/lib/wine (as Mandrake Cooker 20030709-2mdk)
   (It is recommended that users using a systemwide configuration belong to "wine" group since Wine requires a writable access to a fake windows system directory (/var/lib/wine)) 
- revise word "%%post" and "%%postun" in old changelogs
- use momorel, %%NoSource, %%make macro

* Wed Mar 12 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (20030219-1m)
- version 20030219

* Sat Mar 16 2002 Kazuhiko <kazuhiko@kondara.org>
- (20020310-2k)

* Thu Mar  7 2002 Kazuhiko <kazuhiko@kondara.org>
- (20020228-4k)
- revise %%post and %%postun script

* Tue Nov 13 2001 Shingo Akagaki <dora@kondara.org>
- (20011004-4k)
- nigittenu

* Fri Oct 19 2001 Toru Hoshina <t@kondara.org>
- (20011004-2k)
- merge from Jirai.

* Sun Oct 06 2001 Motonobu Ichimura <famao@kondara.org>
- (20011004-3k)
- up to 20011004

* Sat Sep 22 2001 Mitsuru Shimamura <mitsuru@diana.dti.ne.jp>
- (20010824-7k)
- fix %%post,%%postun section

* Tue Sep  4 2001 Shingo Akagaki <dora@kondara.org>
- (20010824-5k)
- add ba-tari font patch

* Sat Sep  1 2001 Mitsuru Shimamura <mitsuru@diana.dti.ne.jp>
- Up to 20010501
- delete Wine-990923-gcc296.patch
- contain wine-20010510-font.patch(from VinePlus),but rejected ;p

* Thu Feb 24 2000 Shingo Akagaki <dora@kondara.org>
- check spec file

* Sun Nov 7 1999 Toru Hoshina <t@kondara.org>
- be a NoSrc :-P

* Wed Oct 27 1999 KUSUNOKI Masanori <masanori@linux.or.jp>
- build against Kondara MNU/Linux 1.0
- prefix /usr/local to /usr
- wine.conf fixed

* Sun Aug  1 1999 Robert Pouliot <krynos@clic.net>
- Fixed a few things for the RPM to build
- The devel part is probably broken, I don't have time to fix now.

* Tue Dec 15 1998 Robert Pouliot <krynos@clic.net>
- Reverted back to /usr/local directories

* Sun Dec 13 1998 Robert Pouliot <krynos@clic.net>
- Integrated changes from Bruce Guenter <bruce.guenter@qcc.sk.ca>

* Mon Nov 9 1998 Robert Pouliot <krynos@clic.net>
- upgraded to 981108 snapshot
- credit to Kjetil Wiekhorst Jrgensen <jorgens@pvv.org>


